/*==================================================================
  !
  !  mardrone application AR-Drone for MeeGo

  ! Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
  ! All rights reserved.
  !
  !  Author:Kate Alhola  kate.alhola@nokia.com
  !
  ! GNU Lesser General Public License Usage
  ! This file may be used under the terms of the GNU Lesser
  ! General Public License version 2.1 as published by the Free Software
  ! Foundation and appearing in the file LICENSE.LGPL included in the
  ! packaging of this file.  Please review the following information to
  ! ensure the GNU Lesser General Public License version 2.1 requirements
  ! will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
  !
  !
  !
  *===================================================================*/
#include <QtGui/QApplication>
#include "dronecontrol.h"
#include "video.h"
#include "gaugehorizon.h"
#include <QDeclarativeView>
#include <QDeclarativeContext>
#include <QDeclarativeEngine>
#include <QtDeclarative>
#include <QtComponents/qdeclarativewindow.h>

int main(int argc, char *argv[])
{
    qmlRegisterType<DroneControl>("Drone", 1, 0, "DroneControl");
    qmlRegisterType<DroneVideo>("Drone", 1, 0, "DroneVideo");
    qmlRegisterType<GaugeHorizon>("Drone", 1, 0, "GaugeHorizon");
    QApplication app(argc, argv);
    QUrl *url;

    qDebug() << "./ardrone.qml exists " << QFile("ardrone.qml").exists();
    qDebug() << ":/ardrone.qml exists " << QFile(":/ardrone.qml").exists();

    if(QFile("ardrone.qml").exists()) {
        QDir::setCurrent(app.applicationDirPath());
        url=new QUrl(QUrl::fromLocalFile("ardrone.qml"));
    }
    else  {
        QDir::setCurrent(":/");
        url=new QUrl("qrc:/ardrone.qml");
    }
    QDeclarativeWindow window(*url);
    window.window()->show();

    return app.exec();
}
